
import hypermedia.net.*; //hypermedia.net-Library importieren, um UDP nutzen zu können
 
UDP udp;  // UDP-Objekt erst

//HUB IP
//String ip       = "193.175.14.10"; // the remote IP address
 
//ZUHAUS IP
String ip       = "192.168.178.222"; // the remote IP address
 
int port        = 80; // Port, an den übertragen werden soll

int lineCounter = 0; // Zähler, der die aktuelle Position des Graphen speichert

void setup() 
{
  size(640,480); // Bühnengröße auf 640x480 Pixel festlegen
  background(0); // Hintergrundfarbe auf Schwarz setzen
  stroke(255); // Strichfarbe auf Weiß setzen

  frameRate(30); // Bildrate auf 30 Bilder pro Sekunde festlegen
  
  udp = new UDP( this, 6000 );  // neue Verbindung an Port 6000 erstellen
  udp.listen( true );           // auf eingehende Nachrichten warten 
  
  fill(0); // Füllfarbe auf Schwarz setzen
  rect(width-20, -1, 20, height+1); // Hintergrund des Scrollbalkens zeichnen
  
  fill(255); // Füllfarbe auf Weiß setzen
  rect(width-20,(height/2)-10, 20, 20); // Scrollbalken zeichnen
}
 
void draw()
{
  if (frameCount%15 == 0) // alle 15 Frames
  {
    updateTemperature(); // Temperatur updaten [Funktion updateTemperature() ausführen]
  }
  
  if (mousePressed) // wenn die Maustaste heruntergedrückt ist
  {
    fill(0); // Füllfarbe auf Schwarz setzen
    rect(width-20, -1, 20, height+1); // Hintergrund des Scrollbalkens zeichnen
    fill(255); // Füllfarbe auf Weiß setzen
    rect(width-20,mouseY-10, 20, 20); // Scrollbalken zeichnen
  }
}

void updateTemperature () // fragt Temperaturdaten vom Server (Arduino) an
{
  udp.send("getTemperature", ip, port ); // Nachricht an Server schicken
}

void mouseReleased () // wenn Maustaste losgelassen wird
{
  int servoRot = floor(map(mouseY, 0, height, 0, 179)); // Servo-Rotation aus Position des Scrollbalkens bestimmen
  udp.send("setServoRot"+nf(servoRot, 3), ip, port ); // neue Servo-Position an Server (Arduino) schicken
}
 
void receive( byte[] data ) // wird ausgeführt, wenn Daten vom Server (z.B. Arduino) empfangen werden
{
  String tempValueText = "";  // leere String-Variable zum speichern der Temperaturdaten als Text anlegen
  int tempValue; // Variable zum speichern der Temperaturdaten als Zahl anlegen
  
  for(int i=0; i < data.length; i++)  // Zeichen für Zeichen die Nachricht in die String-Variable übertragen
  {
    tempValueText = tempValueText + char(data[i]);
  }

  tempValue = int(tempValueText); // eingelesenen Text in Zahlenwert umwandeln und in Tempvalue speichern
  
  line(lineCounter, height, lineCounter, map(tempValue, 0, 511, height, 0)); // weiße Linie zeichnen, die dem ausgelesenen Wert entspricht
  stroke(0); // Strichfarbe auf Schwarz einstellen
  line(lineCounter, map(tempValue, 0, 511, height, 0), lineCounter, 0); // schwarze Linie zeichnen, die den übrigen vertikalen Raum ausfüllt
  stroke(255); // Strichfarbe auf Weiß einstellen
  fill(0,5); // Füllfarbe auf Schwarz, Alpha 50% einstellen
  rect(-1,-1,width-19,height+1); // schwarzes Rechteck zeichnen, um zuvor gezeichnete Linien langsam verblassen zu lassen
  
  if (lineCounter < width-20-4) // wenn horizontale Position des Graphen kleiner als Zeichenfläche
    lineCounter += 4;           // aktuelle Position 4 Pixel erhöhen
  else                          // wenn nicht
    lineCounter = 0;            // aktuelle Position auf 0 setzen
}
